//
// Computergraphik II
// Prof. Dr. Juergen Doellner
// Wintersemester 2001/02
// 
// Rahmenprogramm zu Aufgabenzettel 1
//

#ifndef CG_ILUM_H
#define CG_ILUM_H

#include "cgapplication.h"
#include "triangle.h"

class Context;

class CGIllumination : public CGApplication {
public:
    CGIllumination();
    virtual ~CGIllumination();

    // Ueberschreibe alle diese Ereignisse:
    virtual void onInit();
    virtual void onDraw();        
    virtual void onIdle();
    virtual void onKey(unsigned char key);    
    virtual void onSize(unsigned int newWidth, unsigned int newHeight);
    
private:      
    
    void setPhongIllumination(const Vector& point, const Vector& normal);
double fatt(const Vector& punkt, const Vector& licht, const int li);

    int size_;
    Triangle* tris_;
    Context* ctx_;

	float zoom_;
	float rotate_;

    // state vars    
    bool stop_; 
	bool phong_;

};

#endif // CG_ILUM_H

